<!-- 系统设置 -->
<template>
  <div>
    <el-tabs type="border-card">
      <el-tab-pane v-for="(item , i ) in data" :key="i" :label="item.name">
        <el-form label-width="120px" class="demo-ruleForm">
          <el-form-item :label="it.name" v-for="(it,index) in item.value" :key="index">
            <div v-if="it.value_type==1">
              <el-input class="w300" auto-complete="off" v-model="it.value"></el-input>
              <p class="c_red">{{it.description}}</p>
            </div>

            <div v-if="it.value_type==6">
              <el-input type="textarea" class="w300" auto-complete="off" v-model="it.value"></el-input>
              <p class="c_red">{{it.description}}</p>
            </div>

            <div v-if="it.value_type==3">
              <el-radio-group v-model="it.value">
                <el-radio
                  :label="index1+''"
                  v-for="(ite,index1) in it.enum"
                  :key="index1+'b'"
                >{{ite}}</el-radio>
              </el-radio-group>
              <p class="c_red">{{it.description}}</p>
            </div>

            <div v-if="it.value_type==2">
              <el-select class="w300" v-model="it.value" placeholder="请选择">
                <el-option
                  :value="index1+''"
                  :label="ite"
                  v-for="(ite,index1) in it.enum"
                  :key="index1+'a'"
                >{{ite}}</el-option>
              </el-select>
              <p class="c_red">{{it.description}}</p>
            </div>

            <div v-if="it.value_type==4">
              <el-switch v-model="it.value"></el-switch>
              <!-- <el-input   class="w300" auto-complete="off" v-model="it.value"></el-input> -->
              <p class="c_red">{{it.description}}</p>
            </div>

            <div v-if="it.value_type==7" @click="clickImg(i,index)">
              <div v-show="false">
                <!-- {{pi=i}}
                {{ci=index}}-->
              </div>
              <el-upload
                class="avatar-uploader"
                :action="m_action"
                :show-file-list="false"
                name="images"
                :with-credentials="true"
                :on-success="handleAvatarSuccess"
              >
                <img v-if="it.value" :src="it.value" class="avatar">
                <i v-else class="el-icon-plus avatar-uploader-icon"></i>
              </el-upload>
              <p class="c_red">{{it.description}}</p>
            </div>

            <div v-if="it.value_type==8" @click="clickImg(i,index)">
              <el-upload
                class="upload-demo"
                name="images"
                :show-file-list="false"
                :action="m_action"
                :on-success="handleAvatarSuccessImgs"
              >
                <el-button size="small" type="primary">点击上传</el-button>
              </el-upload>
              <div class="flex">
                <div class="imgss" v-for="(ii,iidex) in it.value" :key="iidex">
                  <i @click="delIMgs(it.value,iidex)" class="el-icon-error imgss_color"></i>
                  <img :src="ii" class="avatar ml10">
                </div>
              </div>
            </div>

            <div v-show="it.value_type==9" class="pb50">
              <div id="editorElem" style="height:600px"></div>
             
              <p class="c_red">{{it.description}}</p>
            </div>

            <div v-show="it.value_type==10" class="pb50">
              <el-time-picker
    is-range
    v-model="it.value"
    value-format="HH:mm:ss"
    range-separator="至"
    start-placeholder="开始时间"
    end-placeholder="结束时间"
    placeholder="选择时间范围">
  </el-time-picker>
             
              <p class="c_red">{{it.description}}</p>
            </div>
          </el-form-item>
        </el-form>
      </el-tab-pane>
    </el-tabs>

    <div class="mt20 ml20">
      <el-button class="w100" :loading="m_loading" type="primary" @click="system_set_edit">提交</el-button>
    </div>
  </div>
</template>
<script>
import E from 'wangeditor'
import config from '../../config/index'
import * as api from '@/api/public.js'
export default {
  data() {
    return {
      data: [],
      pi: '',
      ci: '',
      type: '1',


      //富文本
      editorContent: '',
      editor: new E('#editorElem'),

    }
  },
  mounted() {

    let type = this.$route.query.type
    console.log(this.$route, type)
    if (type) {
      this.type = 0
    }
    this.system_set()
  },
  methods: {
    clickImg(i, index) {
      this.pi = i
      this.ci = index
    },

    system_set() {
      api.system_set({ type: this.type }).then(res => {
        console.log(res.data)

        this.data = res.data.map((item, index) => {
          let it = JSON.parse(JSON.stringify(item))
          if (!it.value) {
            return it
          }
          it.value = it.value.map(i => {
            if (i.value_type == 8) {
              if (!i.value) {
                i.value = []
                i.imgList = []
              } 

            }else if(i.value_type == 9) {
                 this.editorContent = i.value
              }
            return i
          })
          return it
        })

        this.$nextTick(()=>{
          
          this.initEdito(this.editorContent)
        })
      })
    },
    system_set_edit() {
      this.m_loading = true
      let data = this._dep(this.data) 
        data = data.map((item, index) => {
          let it = JSON.parse(JSON.stringify(item))
          if (!it.value) {
            return it
          }
          it.value = it.value.map(i => {
           if(i.value_type == 9) {
                i.value= this.editorContent 
              }
            return i
          })
          return it
        })
      api.system_set_edit({data}).then(res => {
        this.m_success('设置成功')
      }).finally(res => {

        this.m_loading = false
      })
    },

    handleAvatarSuccess(res, file) {
      this.data[this.pi].value[this.ci].value = res.data
    },

    handleAvatarSuccessImgs(res, file) {
      this.data[this.pi].value[this.ci].value.push(res.data)
    },

    handlePreviewImgs(file, fileList) {
      console.log(file, fileList)
    },

    delIMgs(imgarr, index) {
      imgarr.splice(index, 1)
    },

    //富文本
    initEdito(value) {
      this.editor.customConfig.onchange = (html) => {
        this.editorContent = html
      }
      this.setUpload()
      this.uploadImgHooks()
      this.editor.create()
      this.editor.txt.html(value)

    },

    //配置图片上传
    setUpload() {
      //this.editor.customConfig.debug = true
      // this.editor.customConfig.uploadImgShowBase64 = true   // 使用 base64 保存图片
      // this.editor.customConfig.uploadImgHeaders = this.m_headers
      this.editor.customConfig.uploadImgServer = this.m_action  // 上传图片到服务器
      this.editor.customConfig.uploadFileName = 'images'
      this.editor.customConfig.uploadImgMaxLength = 1 //最大上传数量
      this.editor.customConfig.uploadImgTimeout = 10000 //超时时间
      this.editor.customConfig.withCredentials = true   //上传cookie
      this.editor.customConfig.menus = [
        'head',  // 标题
        'bold',  // 粗体
        'fontSize',  // 字号
        'fontName',  // 字体
        'italic',  // 斜体
        'underline',  // 下划线
        'strikeThrough',  // 删除线
        'foreColor',  // 文字颜色
        'backColor',  // 背景颜色
        'link',  // 插入链接
        'list',  // 列表
        'justify',  // 对齐方式
        'quote',  // 引用
        //'emoticon',  // 表情
        'image',  // 插入图片
        'table',  // 表格
        'video',  // 插入视频
        'code',  // 插入代码
        'undo',  // 撤销
        'redo'  // 重复

      ]
    },
    //处理图片上传过程
    uploadImgHooks() {
      let that = this
      this.editor.customConfig.uploadImgHooks = {
        success: function (xhr, editor, result) {
          // 图片上传并返回结果，图片插入成功之后触发
          // xhr 是 XMLHttpRequst 对象，editor 是编辑器对象，result 是服务器端返回的结果
          console.log(result)
          // that.uploadSuccess(result)
        },
        fail: function (xhr, editor, result) {
          console.log(result, xhr)

          console.log('失败')
        },
        error: function (xhr, editor) {

          console.log('错误')
        },
        customInsert: function (insertImg, result, editor) {
          // 图片上传并返回结果，自定义插入图片的事件（而不是编辑器自动插入图片！！！）
          // insertImg 是插入图片的函数，editor 是编辑器对象，result 是服务器端返回的结果

          // 举例：假如上传图片成功后，服务器端返回的是 {url:'....'} 这种格式，即可这样插入图片：
          console.log(result)
          insertImg(result.data)

          // result 必须是一个 JSON 格式字符串！！！否则报错
        }

      }
      this.editor.customConfig.customAlert = function (info) {

        alert('自定义提示：' + info)
      }
    },

    //上传成功
    uploadSuccess(response) {
      console.log(response)
      this.imageUrl = response.filename
      // this.appendImg(response.filename)
      this.appendImg()
    },


    //插入图片
    appendImg(url) {
      let img = `<img src="${url}">`
      this.editor.txt.append(img)
    },
  }
}

</script>
<style lang='scss' scoped>
.c_red {
  color: red;
}

.avatar-uploader .el-upload {
  border: 1px dashed #d9d9d9;
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}
.avatar-uploader .el-upload:hover {
  border-color: #409eff;
}
.avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 178px;
  height: 178px;
  line-height: 178px;
  text-align: center;
  border: 1px dashed #d9d9d9;
}
.avatar {
  width: 178px;
  height: 178px;
  display: block;
  border: 1px dashed #d9d9d9;
}

.imgss {
  position: relative;
  .imgss_color {
    position: absolute;
    top: 5px;
    right: 5px;
    font-size: 18px;
    color: #999;
  }
  .imgss_color:hover {
    color: #333;
  }
}
</style>